' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/03/14 
'
' Color Extraction Sample Program
' -----------------------------------------------------------------
Imports System
Imports System.Runtime.InteropServices

Public Class Form_ColorExtraction_Sample

    Private m_img_src As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()        '摜i[̈iǍ݉摜j
    Private m_img_dst As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()        '摜i[̈iFo摜j
    Private m_overlay As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay        '\I[o[CNX錾

    Private PTRchartArray As fvalgcli.F_COLOR_CHART_PTR                         'F[z
    Private m_NormType As fvalgcli.f_colorcheck_norm_type                       'm^Cv
    Private m_Weight As fvalgcli.DOUBLE_PTR                                     'd݌W

    Dim intErr As Integer                                                       'G[ԍi[ϐ

    Private Sub Form_ColorExtraction_Sample_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'FIECȕ
        fvalgcli.api.fnFIE_setup()

        'F[zm
        PTRchartArray = fvalgcli.F_COLOR_CHART_PTR.alloc(1)

        'p[^̏
        m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_CHEBYSHEV
        m_Weight = fvalgcli.DOUBLE_PTR.Zero

        'mʃR{{bNX
        ComboBoxNormType.Items.Clear()
        ComboBoxNormType.Items.Add("`FrVFtm")
        ComboBoxNormType.Items.Add("}nb^m")
        ComboBoxNormType.Items.Add("[Nbhm")
        ComboBoxNormType.Items.Add("dݕt[Nbhm")
        ComboBoxNormType.Items.Add("}nmrXm")
        ComboBoxNormType.Items.Add("U")
        ComboBoxNormType.Items.Add("e͈͊")
        ComboBoxNormType.SelectedIndex = 0

        'dݕt[NbhmȊO͏d݌WgpȂ
        NumericUpDownWeight1.Enabled = False
        NumericUpDownWeight2.Enabled = False
        NumericUpDownWeight3.Enabled = False

        'UAe͈͊ȊO͋e͈͂͐擪gpȂ
        NumericUpDownTolerance2.Enabled = False
        NumericUpDownTolerance3.Enabled = False

        '摜IuWFNg摜r[ɐݒ
        CFviImageView1.Image = m_img_src
        m_overlay.Image = m_img_src

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub Form_ColorExtraction_Sample_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub Form_ColorExtraction_Sample_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'mۂJ
        PTRchartArray.Dispose()
        m_Weight.Dispose()
        fvalgcli.api.fnFIE_teardown()

    End Sub

    ''' <summary>
    ''' Load File {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Ώۉ摜ǂݍ݂܂B
    ''' </remarks>
    Private Sub ButtonLoadFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadFile.Click
        Dim ofdlg As OpenFileDialog = New OpenFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"

        If (ofdlg.ShowDialog(Me) = DialogResult.OK) Then
            ''
            '' 摜t@Cǂݍ
            ''
            Try
                '̊֐́AȈՓIɉ摜t@C̃[hŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.LoadImageFile(ofdlg.FileName, m_img_src, FVIL.PixelMode.Unpacking)

                '摜IuWFNg摜r[ɐݒ
                CFviImageView1.Image = m_img_src

                'ĕ`
                CFviImageView1.FitImageSize()
                CFviImageView1.Refresh()

                'ǂݍރt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Load(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Load(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim warning As String = String.Format(" : code={0} func={1}", ex.ErrorCode, ex.Function)
                MessageBox.Show(warning, "t@Cǂݍ݂ŃG[܂B", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Catch ex As System.NotSupportedException
                Dim warning As String = ex.Message
                MessageBox.Show(warning, "t@Cǂݍ݂ŃG[܂B", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End Try
        End If

    End Sub

    ''' <summary>
    ''' F[͈͐ݒ`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' F[͈̏͂ݒ肵܂B
    ''' </remarks>
    Private Sub CheckBoxSetArea_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxSetArea.CheckedChanged
        If (CheckBoxSetArea.Checked) Then
            '͈͂̐ݒ
            CFviImageView1.Image = m_img_src
            CFviImageView1.SetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID, True)
        Else
            CFviImageView1.SetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID, False)
        End If
        'ĕ`
        CFviImageView1.Refresh()

    End Sub

    ''' <summary>
    ''' Fos{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Fȍs܂B
    ''' </remarks>
    Private Sub ButtonExtraction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExtraction.Click
        'F[擾
        fn_get_color_char()
        'F[璊o摜
        fnColor_extract()

        CheckBoxSetArea.Checked = False

    End Sub

    ''' <summary>
    ''' F[擾֐
    ''' </summary>
    ''' <remarks>
    ''' F[擾܂B
    ''' </remarks>
    Private Sub fn_get_color_char()
        Try
            't@Cǂݍ񂾉摜擾
            Dim Child_X As Integer = m_img_src.Window.X
            Dim Child_Y As Integer = m_img_src.Window.Y
            Dim Child_width As Integer = m_img_src.Window.Width
            Dim Child_height As Integer = m_img_src.Window.Height

            '摜F[擾ӏ̃`Ch摜쐬
            Dim hChild As fvalgcli.FHANDLE
            hChild = fvalgcli.api.fnFIE_img_child_alloc(m_img_src.GetFIE(), Child_X, Child_Y, Child_width, Child_height)

            'F[擾
            intErr = fvalgcli.api.fnFIE_colorchart_calc_image(hChild, IntPtr.Zero, PTRchartArray)
            '`Ch摜J
            hChild.Dispose()
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' o摜֐
    ''' </summary>
    ''' <remarks>
    ''' F[璊o摜𐶐܂B
    ''' </remarks>
    Private Sub fnColor_extract()
        Try
            Dim tolerance As fvalgcli.DOUBLE_PTR = fvalgcli.DOUBLE_PTR.Zero
            't@Cǂݍ񂾉摜擾
            Dim width As Integer = m_img_src.HorzSize
            Dim height As Integer = m_img_src.VertSize
            Dim type As Integer = m_img_src.ImageType
            Dim channel As Integer = m_img_src.Channel

            '擾摜gpďo͗p̉摜
            m_img_dst.SetSize(width, height, type, channel)

            'e͈͂ݒ
            tolerance = fvalgcli.DOUBLE_PTR.alloc(3)
            tolerance(0) = NumericUpDownTolerance1.Value
            tolerance(1) = NumericUpDownTolerance2.Value
            tolerance(2) = NumericUpDownTolerance3.Value
            'd݌Wݒ
            m_Weight.Dispose()
            If (m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_WEIGHTED_EUCLIDEAN) Then
                m_Weight = fvalgcli.DOUBLE_PTR.alloc(3)
                m_Weight(0) = NumericUpDownWeight1.Value
                m_Weight(1) = NumericUpDownWeight2.Value
                m_Weight(2) = NumericUpDownWeight3.Value
            Else
                'dݕt[NbhmȊO͏d݌WNULLɂ
                m_Weight = fvalgcli.DOUBLE_PTR.Zero
            End If

            'Fo
            intErr = fvalgcli.api.fnFIE_color_extraction(m_img_src.GetFIE(), m_img_dst.GetFIE(), PTRchartArray, 1, m_NormType, m_Weight, tolerance, True)
            CFviImageView1.SetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID, False)

            CFviImageView1.Image = m_img_dst
            'ĕ`
            CFviImageView1.Refresh()
            'mۂJ
            tolerance.Dispose()
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' m^CvR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m^CvI܂B
    ''' </remarks>
    Private Sub ComboBoxNormType_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxNormType.SelectionChangeCommitted
        'm^Cv
        Select Case ComboBoxNormType.SelectedIndex
            Case 0      '`FrVFtm
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_CHEBYSHEV
                NumericUpDownTolerance2.Enabled = False
                NumericUpDownTolerance3.Enabled = False
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
            Case 1      '}nb^m
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_MANHATTAN
                NumericUpDownTolerance2.Enabled = False
                NumericUpDownTolerance3.Enabled = False
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
            Case 2      '[Nbhm
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_EUCLIDEAN
                NumericUpDownTolerance2.Enabled = False
                NumericUpDownTolerance3.Enabled = False
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
            Case 3      'dݕt[Nbhm
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_WEIGHTED_EUCLIDEAN
                NumericUpDownTolerance2.Enabled = False
                NumericUpDownTolerance3.Enabled = False
                NumericUpDownWeight1.Enabled = True
                NumericUpDownWeight2.Enabled = True
                NumericUpDownWeight3.Enabled = True
            Case 4      '}nmrXm
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_MAHALANOBIS
                NumericUpDownTolerance2.Enabled = False
                NumericUpDownTolerance3.Enabled = False
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
            Case 5      'U
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_VARIANCE
                NumericUpDownTolerance2.Enabled = True
                NumericUpDownTolerance3.Enabled = True
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
            Case 6      'e͈͊
                m_NormType = fvalgcli.f_colorcheck_norm_type.F_CC_TOLERANCE
                NumericUpDownTolerance2.Enabled = True
                NumericUpDownTolerance3.Enabled = True
                NumericUpDownWeight1.Enabled = False
                NumericUpDownWeight2.Enabled = False
                NumericUpDownWeight3.Enabled = False
        End Select

    End Sub

    ''' <summary>
    ''' F[Ǎ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' F[Ǎ݂܂B
    ''' </remarks>
    Private Sub ButtonLoadParam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadParam.Click
        Dim chartArray As fvalgcli.F_COLOR_CHART
        chartArray = fvalgcli.F_COLOR_CHART.init

        OpenFileDialog1.FileName = "param.ini"
        OpenFileDialog1.Filter = "ini t@C (*.ini)|*.ini"
        OpenFileDialog1.DefaultExt = "*.ini"
        If ((OpenFileDialog1.FileNames.Length <= 0) Or (OpenFileDialog1.ShowDialog() = DialogResult.Cancel)) Then
            Exit Sub
        End If

        Dim Reader As New IO.StreamReader(OpenFileDialog1.FileName)
        chartArray.color(0) = Reader.ReadLine()
        chartArray.color(1) = Reader.ReadLine()
        chartArray.color(2) = Reader.ReadLine()
        chartArray.flag = Reader.ReadLine()
        chartArray.mat(0) = Reader.ReadLine()
        chartArray.mat(1) = Reader.ReadLine()
        chartArray.mat(2) = Reader.ReadLine()
        chartArray.mat(3) = Reader.ReadLine()
        chartArray.mat(4) = Reader.ReadLine()
        chartArray.mat(5) = Reader.ReadLine()
        PTRchartArray.Item(0) = chartArray
        Reader.Close()

    End Sub

    ''' <summary>
    ''' F[ۑ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' F[ۑ܂B
    ''' </remarks>
    Private Sub ButtonSaveParam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveParam.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.FileName = "param.ini"
        ofdlg.Filter = "ini t@C (*.ini)|*.ini"
        ofdlg.DefaultExt = "*.ini"
        ofdlg.OverwritePrompt = True
        If ((ofdlg.FileNames.Length <= 0) Or (ofdlg.ShowDialog() = DialogResult.Cancel)) Then
            Exit Sub
        End If

        Dim Writer As New IO.StreamWriter(ofdlg.FileName)
        Writer.WriteLine(PTRchartArray.Item(0).color(0))
        Writer.WriteLine(PTRchartArray.Item(0).color(1))
        Writer.WriteLine(PTRchartArray.Item(0).color(2))
        Writer.WriteLine(PTRchartArray.Item(0).flag)
        Writer.WriteLine(PTRchartArray.Item(0).mat(0))
        Writer.WriteLine(PTRchartArray.Item(0).mat(1))
        Writer.WriteLine(PTRchartArray.Item(0).mat(2))
        Writer.WriteLine(PTRchartArray.Item(0).mat(3))
        Writer.WriteLine(PTRchartArray.Item(0).mat(4))
        Writer.WriteLine(PTRchartArray.Item(0).mat(5))
        Writer.Close()

    End Sub

End Class
